//=====================================================================================================================
// Name        : NewPartitions3.cpp
// Author      : Us
// Version     : 1.0
// Copyright   : GNU
// Description : DIMENSION 6: Finds  partitions  of the  integral  value (24)  into 
//               6  (number of edges) positive  integers - there are no cycles - that 
//               make the determinants of the block components of A[3] all equal to 0    
//===================================================================================================================== 

#include <iostream>
#include <fstream>
#include <stdio.h>
#include <numeric>
#include <cstdlib>
#include <vector>
#include <list>


using namespace std;

static ofstream myfile;

// Please insert in the line below the variables x1,x2,...,xnv, 
// where nv = number of edges - number of cycles 

int CalculDet(unsigned short x1,unsigned short x2,unsigned short x3,unsigned short x4,unsigned short x5,unsigned short x6)
{ 
    return -(x2*(x3*(x5*(4 - 3*x6) + x4*(4 + 2*x5*(-2 + x6) - 3*x6)) + 4*x5*x6 + x4*(x5*(4 - 3*x6) + 4*x6))) + x3*(-4*x5*x6 + x4*(-4*x6 + x5*(-4 + 3*x6))) + x1*(x3*(4*x5*(-1 + x6) + x4*(-4 + 3*x5 + 4*x6 - 2*x5*x6)) + x2*(x5*(x3*(3 - 2*x6) + 4*(-1 + x6)) + x4*(-4 + 3*x5 + x3*(3 + x5*(-2 + x6) - 2*x6) + 4*x6 - 2*x5*x6)));
};

bool validSet(unsigned short * firstNum, unsigned short l)
{

  // Please insert in the line below the expression "l*firstNum[0],...,l*firstNum[cardI-3]",
  // substituting cardI by the number of edges of the multigraph

	if(	0 == CalculDet(l,l*firstNum[0],l*firstNum[1],l*firstNum[2],l*firstNum[3],l))
	{       myfile<< l<<" ";

	  // Please substitute "?" below the number of edges minus 2

		for( int i = 0; i<4; i++) myfile<< l*firstNum[i]<<" ";
		myfile<< l<<" ";
		myfile<<endl;
	}
	return true;
};


void part(unsigned short k, unsigned short t, unsigned short l)
{

  // Attention: Partitions with no zeros where, since there are no cycles, the 1st and last magnitudes are equal to l:

	unsigned short r[k];
	int i,j,s,m;
        m=t/l-2;
	r[0]=m-k+1;
        for(i=1;i<k;i++){
		r[i]=1;	}
        validSet(r,l);
        while(r[k-1]!=m-k+1){
		i=k;
		while(r[--i]==1);
		if(i!=k-1){
			r[i]--;
			r[i+1]=2;
                        validSet(r,l);
                }
		else{
			while(r[--i]==1);
			r[i]--;
			s=r[k-1];
			r[k-1]=1;
			r[i+1]=s+1;
		        validSet(r,l);
               }
	}
};


int main()
{

 // Please assign the values of the necessary constants: m= dimension of the manifold, z= value of the integral, nc= number of cycles of the graph

    int m=6;
   
    int z=24;
   
    int nc=0;
   
    
    // **** Computes the  number of edges

    int cardI = (m/2+1)*m/4; 

    // *** writes the partitions in the file OutputPart?.txt where,
    // since nc=0, the first element is equal to the last and is a divisor of the value of the integral
    // smaller or equal than m/2+1; the other elements of the partition are multiples of this divisor; 
    

    // Please substitute "#" below by the position of the multigraph in the list "lff"
 
     cout << "Writing partitions to the file: OutputPart3.txt"<<endl;
     myfile.open ("OutputPart3.txt");

     // Please substitute "#" below by the number of constants C dividing z between 1 and m/2 + 1
    

     unsigned short r[4]; r[0]=1;r[1]=2;r[2]=3;r[3]=4;
     for(int i=0; i<4; i++){         
       part(cardI-2,z,r[i]);
     }
     myfile.close();
     cout << "Finished. \n";
     cout << "\n";

     return 0;
}
