//=====================================================================================================================
// Name        : NewPartitions4.cpp
// Author      : Us
// Version     : 1.0
// Copyright   : GNU
// Description : DIMENSION 6: Finds   partitions  of the  integral  value (24)  into 
//               5  (number of edges -  number of cycles)  positive   integers  that 
//               make the determinants of the block components of A[4] all equal to 0    
//===================================================================================================================== 

#include <iostream>
#include <fstream>
#include <stdio.h>
#include <numeric>
#include <cstdlib>
#include <vector>
#include <list>
#include <cmath>


using namespace std;

static ofstream myfile;

// Please insert in the line below the variables x1,x2,...,xnv, 
// where nv = number of edges - number of cycles 

int CalculDet(unsigned short x1,unsigned short x2,unsigned short x3,unsigned short x4,unsigned short x5)
{ 
  return x3*(4 - 3*x4)*x5 + x2*((4 - 3*x4)*x5 + x3*(4 - 3*x5 + x4*(-3 + 2*x5))) + x1*(x3*(4 - 4*x5 + x4*(-3 + 2*x5)) + x2*(4 - 4*x5 + x4*(-3 + 2*x5) + x3*(-3 - x4*(-2 + x5) + 2*x5)));
};

bool validSet(unsigned short * firstNum, unsigned short l)
{

  // Please insert in the line below the expression "l*firstNum[0],...,l*firstNum[nv-1]", substituiting
  // nv by the number of edges - 1 -the number of cycles of the multigraph

  if(	0 == CalculDet(l,l*firstNum[0],l*firstNum[1],l*firstNum[2],l*firstNum[3]))
  	
{      myfile<< l<<" ";
	  //Please substitute "?" the number of edges - the number of cycles -1

  		for( int i = 0; i<4; i++) myfile<< l*firstNum[i]<<" ";
	        myfile<<endl;
  	}
  	return true;
	};



void part(unsigned short k, unsigned short t, unsigned short l)
{

  // Attention: Partitions with no zeros where, since there is an edge from the min to P_1  the 1st  magnitude is equal to l:

	unsigned short r[k];
	int i,j,s,m;
	m=t/l-1;
	r[0]=m-k+1;
        for(i=1;i<k;i++){
		r[i]=1;	}
        validSet(r,l);
	while(r[k-1]!=m-k+1){
		i=k;
		while(r[--i]==1);
		if(i!=k-1){
			r[i]--;
			r[i+1]=2;
                        validSet(r,l);
		}
		else{
			while(r[--i]==1);
			r[i]--;
			s=r[k-1];
			r[k-1]=1;
			r[i+1]=s+1;
		        validSet(r,l);

		}
	}
};


int main()
{

 // Please assign the values of the necessary constants: m= dimension of the manifold, z= value of the integral, nc= number of cycles of the graph

    int m=6;
   
    int z=24;
   
    int nc=1;
   
    
    // **** Computes the  number of edges

    int cardI = (m/2+1)*m/4; 

    // *** writes the partitions in the file OutputPart?.txt where the first element is a divisor of the value of the integral
    // smaller or equal than m/2+1; the other elements of the partition are multiples of this divisor;

    // Please substitute "#" below by the position of the multigraph in the list "lff"
 
     cout << "Writing partitions to the file: OutputPart4.txt"<<endl;
     myfile.open ("OutputPart4.txt");

// Please substitute "#" below by the number of constants C dividing z between 1 and m/2 + 1

      unsigned short r[4]; r[0]=1;r[1]=2;r[2]=3;r[3]=4;
      for(int i=0; i<4; i++){


     part(cardI-nc-1,z,r[i]);

      }
     myfile.close();
     cout << "Finished. \n";
     cout << "\n";

     return 0;
}
